
class Error(Exception):
    pass

class XMLWidgetEventRouter:
    """Routes events from rendered HTML widgets to XML widgets.
    """
    
    def __init__(self):
	self._events = []

    def register_event(self, event_name, widget, node):
	"""Register an event with the router.
	
	event_name - the name of the event (is method on widget)
	widget     - the widget that handles the event
	node       - the node the widget is working for
	"""
	# add event to list
	self._events.append((event_name, widget, node))
	# return unique id for this event (index into list)
	return len(self._events) - 1

    def clear_events(self):
	"""Clear all events.
	"""
	self._events = []

    def route_event(self, event_id, manager, REQUEST):
	"""Route the event to the right widget.
	
	event_id - the id of the event that occured
	manager  - XMLWidgetManager used
	REQUEST  - Zope REQUEST object
	"""
	if (event_id < 0) or (event_id >= len(self._events)):
	    raise Error, "Event id %s does not exist. Event list "\
		  "contains %s events." % (event_id, len(self._events))
    
	event_name, widget, node = self._events[event_id]
	# let the widget handle the event
	widget.handle_event(event_name, manager, node, REQUEST)
