class XMLWidgetManagerBase:
    """Translates an XMLDocument to HTML document with widgets.

    * Independent translation for each recognized XML node.

    * Passes HTML 'events' on to widgets that registered for these events.

    NOTE: base class for a ZClass.
    """
    def init(self, widgetfinder, eventrouter):
	"""Explicit initialization.
	"""
	self.widgetfinder = widgetfinder
	self.eventrouter = eventrouter
    

    # for __call__ to work, index_html must be set to None
    index_html = None
    
    def __call__(me, self, REQUEST):
	"""Call this ZClass as a DTML Method on an XML Node. Render result.
	
 	me      - instance of this XMLWidgetManager
	self    - object we're calling this method on (an XMLNode)
	REQUEST - Zope REQUEST object
	result  - rendered HTML.
	"""
	# pass it on to render
	return me.render(self, REQUEST)
    
    def render(self, node, REQUEST):
	"""Render result.

	node    - the XMLNode to render
	REQUEST - Zope REQUEST object
	result  - rendered HTML.
	"""
	# find the widget to use for rendering
	widget = self.widgetfinder.getWidget(node)
	if widget is None:
	    raise Error, "Unable to render %s." % node
	return widget.render(self, node, REQUEST)

    def event(self, REQUEST):
	"""Route events from HTML on to widgets on nodes.
	REQUEST  - Zope request object, should contain even_id

	NOTE: Events can modify the rendering procedure and/or the
	XMLDocument; rerender to see the result
	"""
	if not REQUEST.has_key('event_id'):
	    raise Error, "No event_id defined in REQUEST."

	self.eventrouter.route_event(int(REQUEST['event_id']), self, REQUEST)

class Error(Exception):
    """Simple error message."""
    pass
