
def insertTop(node, node_name):
    """Insert a new element node at the top of the list of this one.
    node   - the node at the top of which to insert
    name   - the name of the new node to insert
    result - the new node
    """
    # create new node
    newNode = createElementNode(node, name)
    # insert it at the top of the node
    node.insertBefore(newNode, node.getFirstChild())
    # return the new node
    return newNode

def insertBottom(node, name):
    """Insert a new element node at the bottom of the list of this one.
    node   - the node at the bottom of which to insert
    name   - the name of the new node to insert
    result - the new node
    """
    # create new node
    newNode = createElementNode(node, name)
    # insert it at the bottom of the node
    node.appendChild(newNode)
    # return the new node
    return newNode

def insertAbove(node, name):
    """Insert a new element node above this one.
    node   - the node above which to insert
    name   - the name of the new node to insert
    result - the new node
    """
    # create new node
    newNode = createElementNode(node, name)
    # insert it above node
    node.getParentNode().insertBefore(newNode, node)
    # return the new node
    return newNode

def insertBelow(node, node_name):
    """Insert a new element node below this one.
    node   - the node below which to insert
    name   - the name of the new node to insert
    result - the new node
    """
    # create new node
    newNode = createElementNode(node, name)
    # insert it below node
    node.getParentNode().insertBefore(newNode, node.getNextSibling())
    # return the new node
    return newNode

def createElementNode(node, name):
    """Create a new element node.
    node   - node in the document in which to create
    name   - name of the new element node
    result - the newly created element node
    """
    return node.getOwnerDocument().createElementNode(name)

def setText(node, text):
    """Set text contents for element node, removes previous nodes inside.
    node - the node in which to set the text node
    text - the text in the text node
    """
    # remove previous child nodes
    for child in node.getChildNodes():
	node.removeChild(child)
    # add a new textnode with new text
    doc = node.getOwnerDocument()
    node.appendChild(doc.createTextNode(text))

    
